/* 	
	файл на основе 3.4.2
	
	version 3.5.0 27.06.19
	s/d - 2018

	step_dir.sdscale - Fmax/10
	sd_control - velocity
	parameters t_imp, s_max
	encoder_velocity
	change outputs
	correct SD_FB
	09.06.18 - 26 bit input
	19.06.18  - 5 SD 1PWM not switch
	correct PWM manegment
	17.12.18
	 rename to_pcisd
	 initialize scale
	 Limp
	 invert_dir
	pcisd_v1.1
*/

#include "rtapi_ctype.h"		/* isspace() */
#include "rtapi.h"		/* RTAPI realtime OS API */
#include "rtapi_app.h"		/* RTAPI realtime module decls */
#include "hal.h"			/* HAL public API decls */
#include <linux/types.h>
#include <linux/pci.h>

/* module information */
MODULE_AUTHOR("");
MODULE_DESCRIPTION("");
MODULE_LICENSE("GPL");


/***********************************************************************
*                macros                      *
************************************************************************/
#define Max_sdchanel 5
#define Max_pause 16777215
#define Kprop 1000

#define ustreg 1      // 0-regim PWM     1-regim step/dir

#define reg_enc0 0
#define reg_enc1 1
#define reg_enc2 2
#define reg_enc3 3
#define reg_enc4 4

#define reg_zero 6

#define reg_in 7

#define reg_dcont0 8
#define reg_dcont1 9
#define reg_dcont2 10
#define reg_dcont3 11
#define reg_dcont4 12

#define reg_stepdir0 16
#define reg_stepdir1 17
#define reg_stepdir2 18
#define reg_stepdir3 19
#define reg_stepdir4 20

#define reg_sdcount0 8
#define reg_sdcount1 9
#define reg_sdcount2 10
#define reg_sdcount3 11
#define reg_sdcount4 12

#define reg_out 14
#define reg_out2 13
#define reg_index 15
#define reg_SWch 23
#define control_reg 30
#define reg_WD 31

#define wd_lock_ad 29

#define VENDORID_dev   (0x2105)
#define num_dev        (0x5555)

#define driver_NAME "to_pcisd"

#define SERV 1000000


#define SERV_o 1000000/SERV

/***********************************************************************
*                STRUCTURES AND GLOBAL VARIABLES                       *
************************************************************************/



struct pci_dev *to_io;

/* this structure contains the runtime data needed by the
   driver for a single port/channel
*/

typedef struct {
	void *mem_base;
  	__u32 io_base;
	int len;
	hal_bit_t *digital_in[32];    /* ptrs for digital input pins 0 - 31 */
	hal_bit_t *digital_in_n[32];
  	hal_bit_t *digital_out[32];    /* ptrs for digital output pins 0 - 31 */
	hal_bit_t *enable_dr; 
	hal_bit_t *index_en[5];

	hal_float_t *enccounts[5];
	hal_float_t *encscale[5];
	hal_float_t *encvel[5];

	hal_float_t *outscale[5];
	hal_float_t *dcontrol[5];

	hal_bit_t *wd_lock;

	hal_float_t *sdscale[Max_sdchanel];
	hal_float_t *digital_out_step[Max_sdchanel];
	hal_float_t *sd_counts[Max_sdchanel];
	hal_float_t *Limp[Max_sdchanel];
	hal_bit_t *invert_dir[Max_sdchanel];
	
	hal_float_t *test_sign;

	__u32 last_pause[Max_sdchanel];
	float des_move;
	__u32 new_count;

	__s32 enc_lv[5];

} to_pci_t;

/* pointer to array of structs in shared memory, 1 per port */
static to_pci_t *device_data;


/* other globals */
static int comp_id;		/* component ID */
static int num_ports;		/* number of ports configured */ 

int WD_start =0;


__u8 rdctr[] = {reg_dcont0,reg_dcont1,reg_dcont2,reg_dcont3,reg_dcont4};//PWM
__u8 renci[] = {reg_enc0,reg_enc1,reg_enc2,reg_enc3,reg_enc4};//encoder
__u8 rstdr[] = {reg_stepdir0,reg_stepdir1,reg_stepdir2,reg_stepdir3,reg_stepdir4};//SD
__u8 count_s[] = {reg_sdcount0,reg_sdcount1,reg_sdcount2,reg_sdcount3,reg_sdcount4};//count pause

/***********************************************************************
*                  LOCAL FUNCTION DECLARATIONS                         *
************************************************************************/
/* These is the functions that actually do the I/O
   everything else is just init code
*/
static void update_port(void *arg, long period);

/***********************************************************************
*                       INIT AND EXIT CODE                             *
************************************************************************/

int rtapi_app_main(void)
{
    char name[HAL_NAME_LEN + 1];
    int n,i,r ;
    int retval=0;

    /* only one port at the moment */
    num_ports = 1;
    n = 0;

//	printk(KERN_ALERT "NNN2 = %X\n",ukr->timp);

    /* STEP 1: initialise the driver */
    comp_id = hal_init(driver_NAME);
	if (comp_id < 0) { 
		rtapi_print_msg(RTAPI_MSG_ERR,"to_pcisd: ERROR: hal_init() failed\n");   
    	return -1;
    }

    /* STEP 2: allocate shared memory for to_hal data */
    device_data = hal_malloc(num_ports * sizeof(to_pci_t));
    if (device_data == 0) {
		rtapi_print_msg(RTAPI_MSG_ERR,"to_pcisd: ERROR: hal_malloc() failed\n");
		r = -1;
		goto fail0;    
    }


////////////PCI INIT...      
   
    to_io = pci_get_device(VENDORID_dev, num_dev, to_io);
    
    if (NULL == to_io) {
		rtapi_print_msg(RTAPI_MSG_ERR,"to_io == NULL\n");  
		hal_exit(comp_id);
		return -1;
    }
    
    device_data->io_base = pci_resource_start(to_io, 0);

    device_data->len = pci_resource_len(to_io, 0);

    rtapi_print_msg(RTAPI_MSG_INFO,"to_pcisd: io_base: %X \n", device_data->io_base); 
   
    device_data->mem_base = ioremap_nocache( device_data->io_base,device_data->len);

	printk(KERN_ALERT "to_pcisd: io_base: %X, mem_base: %p\n", device_data->io_base, device_data->mem_base);

	if (device_data->mem_base == NULL) {
                rtapi_print_msg(RTAPI_MSG_ERR,"not_remap\n");
                r = -ENODEV;
                goto fail0;
	}
	
//    writel(0x6000000A,(device_data->mem_base)+(reg_WD*4));

	writel(0x600000A0,(device_data->mem_base)+(control_reg*4));
	writel(0x60000000,(device_data->mem_base)+(control_reg*4));

//////////////////////
//////////////////////
//////////////////////

/* ///////////////// Export IO pin's ////////////////////////////////////////////*/

    /* export write only HAL pin's for the input bit */
	for ( i=0; i<=31;i++) {
		retval = hal_pin_bit_newf(HAL_OUT, &(device_data->digital_in[i]),comp_id, "to_pcisd.%d.pins.pin-%02d-in", 1, i);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR, "to_pcisd: ERROR: port %d var export failed with err=%i\n", n + 1,retval);
			r = -1;
			goto fail1;
		}

		retval = hal_pin_bit_newf(HAL_OUT, &(device_data->digital_in_n[i]),comp_id, "to_pcisd.%d.pins.pin-%02d-in-n", 1, i);
      	if (retval < 0) {
        	rtapi_print_msg(RTAPI_MSG_ERR, "to_pcisd: ERROR: port %d var export failed with err=%i\n", n + 1,retval);
        	r = -1;
        	goto fail1;
      	}
	}

    /* export read only HAL pin's for the output bit */
	for ( i=0; i<=31;i++) {
		retval = hal_pin_bit_newf(HAL_IN, &(device_data->digital_out[i]),comp_id, "to_pcisd.%d.pins.pin-%02d-out", 1, i);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"to_pcisd: ERROR: port %d var export failed with err=%i\n", n + 1,retval);
			r = -1;
			goto fail1;
		}
	}


///////////////////////////
///////////////////////////
///////////////////////////

	/* export read only HAL pin's DRIVE_ENABLE */

	retval = hal_pin_bit_newf(HAL_IN, &(device_data->enable_dr),comp_id, "to_pcisd.%d.enable_drive", 1);

	if (retval < 0) {
	  rtapi_print_msg(RTAPI_MSG_ERR,"to_pcisd: ERROR: enable_dr var export failed with err=%i\n",retval);
  	  r = -1;
	  goto fail1;
	}

/////////////////////////////
/////////////////////////////
/////////////////////////////

	/* export encoder signal */

	for ( i=0; i<=4;i++) {
		/* encoder_count */
		retval = hal_pin_float_newf(HAL_OUT, &(device_data-> enccounts[i]), comp_id, "to_pcisd.%d.feedback.encoder%d", 1, i);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"to_pcisd: ERROR:  err encoder=%i\n", retval);
			r = -1;
			goto fail1;
		}
				/* encoder_scale */
		retval = hal_pin_float_newf(HAL_IN, &(device_data-> encscale[i]), comp_id, "to_pcisd.%d.feedback.enc_scale%d", 1, i);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"to_pcisd: ERROR:  err enc_scale=%i\n", retval);
			r = -1;
			goto fail1;
		}

		*device_data-> encscale[i] = 1;

				/* index */
		retval = hal_pin_bit_newf(HAL_IO, &(device_data->index_en[i]),comp_id, "to_pcisd.%d.feedback.index_en%01d", 1, i);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"to_pcisd: ERROR: port %d var export failed with err=%i\n", n + 1,retval);
			r = -1;
			goto fail1; 
		}  
			/* encoder_velocity */
		retval = hal_pin_float_newf(HAL_IN, &(device_data-> encvel[i]), comp_id, "to_pcisd.%d.feedback.enc_vel%d", 1, i);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"to_pcisd: ERROR:  err enc_velocity=%i\n", retval);
			r = -1;
			goto fail1;
		}   
	}
	
//////////////////////////////
/////////////////////////////
/////////////////////////////
	/* export control drive PWM*/

	i=0;
	//for ( i=0; i<=4;i++) {
		retval = hal_pin_float_newf(HAL_IN, &(device_data-> dcontrol[i]), comp_id, "to_pcisd.%d.PWM.dcontrol%d", 1, i);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"to_pcisd: ERROR:  err dcontrol=%i\n", retval);
			r = -1;
			goto fail1;
		}

		retval = hal_pin_float_newf(HAL_IN, &(device_data-> outscale[i]), comp_id, "to_pcisd.%d.PWM.out_scale%d", 1, i);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"to_pcisd: ERROR:  err out_scale=%i\n", retval);
			r = -1;
			goto fail1;
		}
	//}

//////////////////////////////
/////////////////////////////
/////////////////////////////
	/* export control drive STEP_DIR*/

	for ( i=0; i<=(Max_sdchanel-1);i++) {
			/* out signals step/dir */
		retval = hal_pin_float_newf(HAL_IN, &(device_data->digital_out_step[i]),comp_id, "to_pcisd.%d.step_dir.outstep%d", 1, i);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"to_pcisd: ERROR:  err out_step=%i\n", retval);
			r = -1;
			goto fail1;
		}
			/* feed back step/dir */
		retval = hal_pin_float_newf(HAL_OUT, &(device_data-> sd_counts[i]), comp_id, "to_pcisd.%d.step_dir.count%d", 1, i);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"to_pcisd: ERROR:  err encoder=%i\n", retval);
			r = -1;
			goto fail1;
		}
			/* scale step/dir */
		retval = hal_pin_float_newf(HAL_IN, &(device_data-> sdscale[i]), comp_id, "to_pcisd.%d.step_dir.escale%d", 1, i);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"to_pcisd: ERROR:  err scale=%i\n", retval);
			r = -1;
			goto fail1;
		}
		*device_data-> sdscale[i] = 1;

		retval = hal_pin_float_newf(HAL_IN, &(device_data-> Limp[i]), comp_id, "to_pcisd.%d.step_dir.Limp%d", 1, i);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"to_pcisd: ERROR:  err Limp=%i\n", retval);
			r = -1;
			goto fail1;
		}
		retval = hal_pin_bit_newf(HAL_IN, &(device_data-> invert_dir[i]), comp_id, "to_pcisd.%d.step_dir.invert_dir%d", 1, i);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"to_pcisd: ERROR:  err invert_dir=%i\n", retval);
			r = -1;
			goto fail1;
		}
		*device_data-> invert_dir[i] = 0;
	}

/////////////////////////////
/////////////////////////////
	retval = hal_pin_bit_newf(HAL_IO, &(device_data->wd_lock),comp_id, "to_pcisd.%d.wd_lock", 1);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"to_pci: ERROR: port %d var export failed with err=%i\n", n + 1,retval);
			r = -1;
			goto fail1; 
		} 

//////////////////////////////
/////////////////////////////
/////////////////////////////

	/* export test signal*/
		retval = hal_pin_float_newf(HAL_OUT, &(device_data-> test_sign), comp_id, "to_pcisd.%d.test_sig", 1);
		if (retval < 0) {
			rtapi_print_msg(RTAPI_MSG_ERR,"to_pcisd: ERROR:  err test_sign=%i\n", retval);
			r = -1;
			goto fail1;
		}


/////////////////////////
////UPDATE
////////////////////////
    /* STEP 4: export function */
	rtapi_snprintf(name, sizeof(name), "to_pcisd.%d.update", n + 1);
	retval = hal_export_funct(name, update_port, device_data, 1, 0,comp_id);
	if (retval < 0) {
		rtapi_print_msg(RTAPI_MSG_ERR,"to_pcisd: ERROR: port %d write funct export failed\n", n + 1);
		r = -1;
		goto fail1;
    }

    rtapi_print_msg(RTAPI_MSG_INFO,"to_pcisd: installed driver for %d card(s)\n", num_ports);
	printk(KERN_ALERT "to_pcisd: installed driver for %d card(s)\n", num_ports);
    hal_ready(comp_id);
    return 0;

fail1:

iounmap((void*)device_data->mem_base);

fail0:

device_data->mem_base = NULL;
hal_exit(comp_id);
return r;

}

void rtapi_app_exit(void)
{	
//	writel(0x60000000,(device_data->mem_base)+(reg_WD*4));
	iounmap((void*)device_data->mem_base);
	hal_exit(comp_id);
	rtapi_print_msg(RTAPI_MSG_INFO,"to_pcisd: exit\n");
	printk(KERN_ALERT "to_pcisd: exit\n");
}


//###########################################################################################################
//
//			FUNCTIONS
//
//###########################################################################################################

int ABS_SUB(__s32 lt1, __s32 lt2)
{
	__s32 lt3;
	if(lt1<lt2)
		lt3 = lt2-lt1;
	else
		lt3 = lt1-lt2;

	if(lt3 < 5)
		return 0;
	else	
		return 1;
}

///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////
///    STEP DIR FUNCTIONS
///////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////

__s32 DDcontr(void *farg,__u8 exr)
{
// Ti = 1000ns
// Tots = 20ns
// Ti_ots = Ti/Tots;
#define Ti_ots 50

	to_pci_t *data_sd;

	__u8 ttz;
	__u32 temp,pack,pause_up;
	float V_cmd;

	__u32  L_N_imp;

	data_sd = farg;

	V_cmd = *(data_sd-> digital_out_step[exr]);
	
	//limp
	L_N_imp = (__u32)*(data_sd-> Limp[exr]) * 2;
	L_N_imp = L_N_imp & 0x0000000F;
	if(L_N_imp == 0) L_N_imp = 4;
	
	//Направление	
	pack = 0;		//установка dir(в переменной pack будем собирать посылку)
	if(V_cmd<0) 
	{
    		pack=1;	      //установка dir
    		V_cmd = -V_cmd; //модуль скорости
  	}
	//inverse
	if(*data_sd-> invert_dir[exr])
	pack = pack ^ 0x00000001;

 	//Ограничение Vin
	if(V_cmd >10) V_cmd = 10;

	ttz = 0x01; // Флаг разрешения выдачи STEP
	if(V_cmd != 0)
		pause_up = (__u32)((10/V_cmd)*(Ti_ots*L_N_imp + 1));
	else
		{
			pause_up = Max_pause;
			ttz = 0;
		}

  	if(pause_up > Max_pause)
		{
			pause_up = Max_pause;
			ttz = 0;
		}

	//enable
  	pack <<= 1;
	pack = pack | ttz;

	//pouse
	pack <<= 30;
	temp = pause_up & 0x00ffffff;
	pack = pack | temp;

	if(ttz) data_sd->last_pause[exr] = pack & 0x80FFFFFF;

	//limp
	L_N_imp <<= 24;
	pack = pack | L_N_imp; 

/*
	//calaulate new_count SD
	if((temp > 5000) && (data_sd->des_move < 0.95))
		data_sd->new_count = (__u32) data_sd->des_move*temp;
	else
		data_sd->new_count = 0xffffffff;
*/

	/////////////////////      test sig       ///////////////
		if(exr == 0)
				*data_sd->test_sign = pause_up & 0x00FFFFFF;
	return pack;
}
/**************************************************************
* REALTIME PORT WRITE FUNCTION                                *
**************************************************************/

void update_port(void *arg, long period){
	to_pci_t *port;
	
	__u32 tmp,_tmp,mask,tmask,tanmask;
	__s32 ikor;
	int pin,k,flagok;
	__u8 lastdir;

	__s32 temp1,temp2;
	float tmpfloat,_tmpfloat;

	port = arg;
	tmask = 0x60000000;
	tanmask = 0xEFFFFFFF;

// WD

	writel(0x6000000A,(device_data->mem_base)+(reg_WD*4));

	if(!WD_start){
		writel(0x60000080,(device_data->mem_base)+(control_reg*4));
		writel(0x60000000,(device_data->mem_base)+(control_reg*4));
		WD_start = 1;
	}

//////////////////////////////////////////////////////////////////////////////	
////////////////////ALL INPUTS///////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

// read digital inputs 	    
	tmp = readl((port->mem_base)+(reg_in*4)); 
      	mask = 0x00000001;
	for (pin=0 ; pin < 32 ; pin++) {
		*(port->digital_in[pin]) = (tmp & mask) ? 1:0 ;
		*(port->digital_in_n[pin]) = (tmp & mask) ? 0:1 ;
		mask <<= 1;
	}

// Index....
	tmp = readl((port->mem_base)+(reg_zero*4));
	mask = 0x01;
	for (pin=0; pin < 5; pin++) {
		if(*port->index_en[pin] && (tmp & mask)){
			*port->index_en[pin] = 0;
		}
		mask <<= 1;
	}

///////////// read encoders /////////////////////////////////////////////

	for ( k=0; k<=4;k++) {
		flagok =1;
		temp1=(__s32)readl((port->mem_base)+(renci[k]*4));

		while (flagok)
		{
			temp2=(__s32)readl((port->mem_base)+(renci[k]*4));
			flagok = ABS_SUB(temp1,temp2);
			temp1 = temp2;			
		}
		*port->enccounts[k] = temp1/(*port->encscale[k]);

		temp2 = temp1 - (port->enc_lv[k]);

		port->enc_lv[k] = temp1;

		temp2 = temp2*1000;

		*port->encvel[k] = (temp2/(*port->encscale[k]))*SERV_o;
	}

///////////// wd_lock /////////////////////////////////////////////

	if(readl((port->mem_base)+(wd_lock_ad*4)) & 0x00000001)
		*port->wd_lock = 1;
	else
		*port->wd_lock = 0;


//////////////////////////////////////////////////////////////////////////////	
////////////////////ALL OUTPUTS///////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

// write index_enable outputs 
     	tmp = 0x0;
     	mask = 0x01;
     	for (pin=0; pin < 5; pin++) {
        	if (*port->index_en[pin]) {
        		tmp |= mask;
        	}
			mask <<= 1;
     	}

		tmp |= tmask;	
		writel(tmp,(port->mem_base)+(reg_index*4)); 

// write digital outputs 
     	tmp = 0x0;
     	mask = 0x01;
     	for (pin=0; pin < 16; pin++) {
        	if (*port->digital_out[pin]) {
        		tmp |= mask;
        	}
			mask <<= 1;
     	}
		tmp |= tmask;
		writel(tmp,(port->mem_base)+(reg_out*4)); 


// write control reg  control_reg

	tmp = 0;
	if (*port->enable_dr) {
		tmp |= 0x00000010;//(1 << bit_en)
        }

	tmp |= tmask;
	tmp &= 0xFFFFFFDF;  //encoders not reset
     	writel(tmp,(port->mem_base)+(control_reg*4)); 

// out to drive

	k=0;
		ikor = (*port->outscale[k])*((*(port-> dcontrol[k]))/10)*0xffff;

		ikor |= tmask;
		ikor &= tanmask;
		writel( ikor,(port->mem_base)+(rdctr[k]*4));



//////////////////////////////////////////////////////////////////////////////	
////////////////////STEP dir section///////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

///////////// read s/d count /////////////////////////////////////////////

	for ( k=0; k<=(Max_sdchanel-1);k++) {
		flagok =1;
		temp1=(__s32)readl((port->mem_base)+(rstdr[k]*4));

		while (flagok)
		{
			temp2=(__s32)readl((port->mem_base)+(rstdr[k]*4));
			flagok = ABS_SUB(temp1,temp2);
			temp1 = temp2;			
		}
		// считываем значение счётчика паузы
		_tmp = (readl((port->mem_base)+(count_s[k]*4)));

		lastdir = 0;
		if(_tmp & 0x01000000)lastdir = 1;
		_tmp &= 0x00FFFFFF;

		// пердыдущее значение счётчика паузы
		tmp = port -> last_pause[k];
 		tmp &= 0x00FFFFFF;
		if(tmp == 0) tmp = 1;

		//находим дробную часть количества импульсов
		_tmpfloat =(float) _tmp/tmp;

		if(_tmpfloat > 1) _tmpfloat = 0;

		port->des_move = _tmpfloat;
		
		//if (port->last_pause[k] & 0x80000000) tmpfloat = 1-_tmpfloat;
		if (lastdir) tmpfloat = 1-_tmpfloat;
		else tmpfloat = _tmpfloat;
		//tmpfloat = _tmpfloat;

		/////////////////////      test sig       ///////////////
		//if(k == 0)
		//		*port->test_sign = tmpfloat;
		//////////////////////////////////////////////////

		*port->sd_counts[k] = (temp1 + tmpfloat)/(*port->sdscale[k]);


		// Step dir out
		tmp = DDcontr(port,k);
		//if(port->new_count != 0xffffffff){
		//	_tmp = (port->new_count & 0x00ffffff)|0xD0000000;
		//	writel( _tmp,(port->mem_base)+(count_s[k]*4));
		//}
		writel(tmp,(port->mem_base)+(rstdr[k]*4));

	}

}
